unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLScene, GLMesh, GLCoordinates, GLWin32Viewer, GLCrossPlatform,
  BaseClasses, GLColor, GLState, VectorTypes,
  VectorGeometry, StdCtrls, GLObjects, ComCtrls;

type
  TForm1 = class(TForm)
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLMesh1: TGLMesh;
    Button1: TButton;
    GLDummyCube1: TGLDummyCube;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    Button5: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    px,py : integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  GLMesh1.Vertices.Clear;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X; py := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X; py := Y;
  end;

end;

procedure TForm1.TrackBar1Change(Sender: TObject);
var
 pp : integer;
 ii : single;
 cc : TVector4f;
begin
 pp := TrackBar1.Position;
 ii := pp/20;
 SetVector(cc,ii,ii,ii);
 GLLightSource1.Diffuse.Color := cc;

 Label1.Caption := Format('L=%4.2f', [ii]);
end;

// limpiar
procedure TForm1.Button2Click(Sender: TObject);
begin
  GLMesh1.Vertices.Clear;
end;

// Triangulo
procedure TForm1.Button1Click(Sender: TObject);
var
  v1,v2,v3,nn : TVector3f;
begin
  SetVEctor(nn,0,0,0);

  SetVector(v1,0,0,0);
  GLMesh1.Vertices.AddVertex(v1,nn,clrBlue);

  SetVector(v2,1.5,0,0);
  GLMesh1.Vertices.AddVertex(v2,nn,clrGreen);

  SetVector(v3,1.5,1.5,0);
  GLMesh1.Vertices.AddVertex(v3,nn,clrRed);

  GLMesh1.CalcNormals(fwCounterClockWise);
end;

// Pared
procedure TForm1.Button3Click(Sender: TObject);
var
  v1,v2,v3,v4,
  nn          : TVector3f;
  kk,n        : integer;
  x,dx        : single;

  c1,c2,c3    : TVector4f;
begin
  SetVector(nn,0,0,0);

  c1 := clrBlue;
  c2 := clrYellow;

  x  := -3;
  N  := 10;
  dx := 2*abs(x)/(N-1);

  for kk := 0 to N - 1 do begin
    SetVector(v1,x,-1,0);
    GLMesh1.Vertices.AddVertex(v1,nn,c1);

    SetVector(v2,x+dx, -1,0);
    GLMesh1.Vertices.AddVertex(v2,nn,c1);

    SetVector(v3,x, 1,0);
    GLMesh1.Vertices.AddVertex(v3,nn,c2);

    SetVector(v4,x+dx, 1,0);

    GLMesh1.Vertices.AddVertex(v2,nn,c1);
    GLMesh1.Vertices.AddVertex(v4,nn,c2);
    GLMesh1.Vertices.AddVertex(v3,nn,c2);

    x := x + dx;

  end;

  GLMesh1.CalcNormals(fwCounterClockWise);
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  v1,v2,v3,v4,
  nn          : TVector3f;
  kk,n        : integer;
  x,dx        : single;
  c,dc        : single;

  c1,c2,c3    : TVector4f;
begin
  SetVector(nn,0,0,0);

  c1 := clrBlue;

  x  := -3;
  N  := 10;
  dx := 2*abs(x)/(N-1);

  c  := 0.0;
  dc := 1/(N-1);

  for kk := 0 to N - 1 do begin
    SetVector(c2,c,c,c);
    SetVector(c3,c+dc,c+dc,c+dc);

    SetVector(v1,x,-1,0);
    GLMesh1.Vertices.AddVertex(v1,nn,c2);

    SetVector(v2,x+dx, -1,0);
    GLMesh1.Vertices.AddVertex(v2,nn,c3);

    SetVector(v3,x, 1,0);
    GLMesh1.Vertices.AddVertex(v3,nn,c2);

    SetVector(v4,x+dx, 1,0);

    GLMesh1.Vertices.AddVertex(v2,nn,c3);
    GLMesh1.Vertices.AddVertex(v4,nn,c3);
    GLMesh1.Vertices.AddVertex(v3,nn,c2);

    x := x + dx;
    c := c + dc;
  end;

  GLMesh1.CalcNormals(fwCounterClockWise);
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  v1,v2,v3,v4,
  nn          : TVector3f;
  kk,n        : integer;
  x,dx        : single;
  a,da        : single;

  c1,c2,c3,cf : TVector4f;
begin
  SetVector(nn,0,0,0);

  c1 := clrBlue;
  c2 := c1;
  cf := clrYellow;

  x  := -3;
  N  := 10;
  dx := 2*abs(x)/(N-1);

  a  := 0.0;
  da := 1/(N-1);

  for kk := 0 to N - 1 do begin
    c2 := VectorLerp(c1,cf,a);
    c3 := VectorLerp(c1,cf,a+da);

    SetVector(v1,x,-1,0);
    GLMesh1.Vertices.AddVertex(v1,nn,c2);

    SetVector(v2,x+dx, -1,0);
    GLMesh1.Vertices.AddVertex(v2,nn,c3);

    SetVector(v3,x, 1,0);
    GLMesh1.Vertices.AddVertex(v3,nn,c2);

    SetVector(v4,x+dx, 1,0);

    GLMesh1.Vertices.AddVertex(v2,nn,c3);
    GLMesh1.Vertices.AddVertex(v4,nn,c3);
    GLMesh1.Vertices.AddVertex(v3,nn,c2);

    x := x + dx;
    a := a + da;
  end;

  GLMesh1.CalcNormals(fwCounterClockWise);
end;

end.
